require 'net/http'
require 'win32ole'

def getrandom(min, max)
	return ((rand * (max-min)) + min).to_i
end

def azStats(server, port)
	begin	
		h = Net::HTTP.new(server, port)
		xml = WIN32OLE.new("Msxml2.DOMDocument.3.0")
		req_id = getrandom(4534082938219,5534082938219)	
		xml.async = true
		xml.loadXML("<REQUEST><METHOD>getDownloads</METHOD><REQUEST_ID>" + req_id.to_s + "</REQUEST_ID></REQUEST>")
		resp = h.post("/process.cgi", xml.xml)
		
		xml.loadXML(resp.body)
		dlspeed = loading = queue = complete = 0
		xml.setProperty("SelectionLanguage", "XPath")
		torrents = xml.documentElement.selectNodes("/RESPONSE/ENTRY/stats")
		
# gather info for the samurize client

		torrents.each { |t|		
			dlspeed += t.selectSingleNode("download_average").text.to_i
			t_status = t.selectSingleNode("status").text
			case t_status
				when "Queued"
					if t.selectSingleNode("completed").text.to_i < 1000
						queue += 1
					else
						complete += 1
					end
				when "Downloading" then loading += 1
				when "Seeding" then complete += 1
			end
		}

# Gather information for the tooltip
		nxml = WIN32OLE.new("Msxml2.DOMDocument.3.0")
		nxml.validateOnParse = false
		nxml.async = false
		xsl = WIN32OLE.new("Msxml2.DOMDocument.3.0")
		xsl.async = false
		tooltip = ""
		
		xslstr = <<-XML_STR
		<?xml version="1.0" encoding="ISO-8859-1"?>
		<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
		<xsl:output method="xml" version="1.0" encoding="iso-8859-1" />
		<xsl:template match="/">
		<torrents>
		<xsl:for-each select="RESPONSE/ENTRY[contains(stats/status, 'Downloading')]">
		<item>
		<name><xsl:value-of select="torrent/name"/></name>
		<done><xsl:value-of select="stats/downloadCompletedLive"/></done>
		<downspeed><xsl:value-of select="stats/download_average"/></downspeed>
		<seeds><xsl:value-of select="scrape_result/seed_count"/></seeds>
		<peers><xsl:value-of select="scrape_result/non_seed_count"/></peers>
		</item>
		</xsl:for-each>
		</torrents>
		</xsl:template>	
		</xsl:stylesheet>
XML_STR
		res = xsl.loadXML(xslstr.gsub("\t", ""))
		
		xml.transformNodeToObject(xsl.documentElement, nxml)
		
		nxml.setProperty("SelectionLanguage", "XPath")
		torrents = nxml.documentElement.selectNodes("/torrents/item")	
		torrents.each { |t|
			tooltip += "%s: %3.1f%%, %3.1fkB/s (S: %d|P: %d)\n" % 
			[	t.selectSingleNode("name").text,
				t.selectSingleNode("done").text.to_f/10,
				t.selectSingleNode("downspeed").text.to_f/1024,
				t.selectSingleNode("seeds").text.to_i,
				t.selectSingleNode("peers").text.to_i]
		}
		
		return "%3.1fkb/s [%d/%d/%d]%%tt%s" % [dlspeed/1024, loading, queue, complete, tooltip.chop]		
	rescue
		puts "Exception: " + $!
		puts $!.backtrace.join("\n")
		return "Az inactive%tt"
	end
end